# Standard Athena system-wide .cshrc file.
#
#	MIT Project Athena
#
#	RCS Information:
#
#	$Source: /paris/source/4.3/usr.athena/RCS/.cshrc,v $
#	$Header: .cshrc,v 1.9 87/11/17 14:51:14 ambar Exp $

# Set the path

set athena_path = (/srvd/patch /usr/athena /bin/athena /usr/bin/X /usr/new \
		/usr/new/mh/bin /usr/ucb /bin /usr/bin /usr/games)

# Useful aliases
#	attach -- Execute attach and source the .attachrc file if appropriate
#	detach -- Execute the .detachrc file (if appropriate) and detach
#			the filesystem
# Note that the attach and detach aliases are each one real line.  This
# must be maintained for the aliases to work; the csh does not allow escapes
# in the middle of aliases.

alias add	'set dir = `/bin/athena/attach -p \!*` ; 					if (! $status && -r $dir/.attachrc) source $dir/.attachrc;                      unset dir'

alias drop									   'set dir = `/bin/grep -w \!:1 /etc/attachtab | /bin/awk {print $7}`; 		if (! $status && -r $dir/.detachrc) source $dir/.detachrc;                   /bin/athena/detach \!*; unset dir'

# Useful aliases in an X environment
#	xlogin -- xlogin takes the same arguments as rlogin but creates a
#		  new window for the remote session and allows programs on
#		  the remote host to open windows on the local display.
#	xresize -- inform the system that a window has changed size.  Normally
#		  this should not be necessary.

if ($?term) then
	if ($term =~ xterm*) then
		alias xlogin 'xhost \!:1; xterm -n "\!:1" -e rlogin \!:*'
		alias xresize	'set noglob; eval `resize`'
	endif
endif
