# Standard Athena system-wide .login file
#
#	MIT Project Athena
#
#	RCS Information:
#
#	$Source: /paris/source/4.3/usr.athena/RCS/.login,v $
#	$Header: .login,v 1.8 88/10/20 21:06:58 shanzer Exp $

# Read cluster-specific information

if (-r /etc/clusterinfo) then
	source /etc/clusterinfo
else
	echo "Unable to read workstation cluster information."
	echo "Some services (including printing) may not work properly."
endif

# Check for temporary home directory, and print a warning if necessary.
# The poor indentation used here allows strings that are closer to going
# all the way across the screen.

if ($?TMPHOME) then
echo ""
echo ""
echo "Your home directory cannot be attached right now.   You may use a"
echo "temporary directory, but"
echo ""
echo "			**** WARNING ****"
echo ""
echo "if you do, any files you make or any mail you incorporate will be"
echo "deleted when you logout and lost forever."
echo ""
echo "Would you like to continue this login session, using a TEMPORARY"
echo -n "directory? (yes,no) [The default is no] "
set answer = ($<)
if ("$answer" =~ [yY]*) then
	echo "Continuing with temporary directory..."
	mkdir ~/Mail
else
	kill -HUP $$
endif
endif

# Environment variables

setenv MANPATH	/usr/man		# Path for manual pages

# Load the X resources

if ( $term =~ xterm* && `/usr/bin/tty` =~ /dev/ttyv* ) then
	if (-r ~/.Xresources) xrdb -load ~/.Xresources 
endif

# Start up Zephyr windowgram client

/usr/etc/zwgc

# Retrieve any new global system messages as a Zephyr message.

if ( $status == 0 ) then
	/bin/athena/get_message -new -zephyr
endif

# Update the OLC server's idea of where you are

/usr/athena/olc who >& /dev/null

# Check on new mail

/usr/new/mh/bin/msgchk -nonotify nomail
