/*
** finding out how full filesystems are
**
*/
#ifndef lint
static char *rcsid="$Id: capacity.c,v 1.2 88/07/07 20:45:49 mjb Exp $";
#endif

#include <sys/param.h>
#include <sys/stat.h>
#ifndef	sun
#include <sys/fs.h>
#else
#include <ufs/fs.h>
#endif	sun
#include <sys/file.h>
#include <stdio.h>
#include <fstab.h>
#ifndef MAX
#define MAX(a,b) ((a) > (b) ? (b) : (a))
#endif

static union {
	struct fs iu_fs;
	char dummy[SBSIZE];
} sb;
#define sblock (sb.iu_fs)

/*
 * the raw device that we want to know how full it is.
 */
static int fi;

/*
 * how_full --
 * returns a percent (eg. 95) indicating how full the filesystem
 * given is.
 */
int
how_full(file)
	char *file;
{
	long lTotal, lAvail, lFree, lUsed, lInodes;
	int disk_prcnt, ino_prcnt;

	if (-1 == (fi = open(file, 0))) {
		perror(file);
		return -1;
	}
	if (-1 == bread(SBLOCK, (char *)&sblock, SBSIZE)) {
		return -1;
	}
	lTotal = sblock.fs_dsize;
	lFree = sblock.fs_cstotal.cs_nbfree * sblock.fs_frag +
		sblock.fs_cstotal.cs_nffree;
	lUsed = lTotal - lFree;
	lAvail = lTotal * (100 - sblock.fs_minfree) / 100;
	    
	disk_prcnt = (lAvail == 0) ? 0 : (double) lUsed / (double) lAvail * 100.0;
	lInodes = sblock.fs_ncg * sblock.fs_ipg;
	lUsed = lInodes - sblock.fs_cstotal.cs_nifree;
	ino_prcnt = (lInodes == 0) ? 0 : (double) lUsed / (double) lInodes * 100.0;
	(void) close(fi);

	return MAX(disk_prcnt, ino_prcnt);
}

static int
bread(bno, buf, cnt)
	daddr_t bno;
	char *buf;
	int cnt;
{
	extern off_t lseek();
	extern int errno;
	int n;

	(void) lseek(fi, (off_t)(bno * DEV_BSIZE), 0);
	if (cnt != (n = read(fi, buf, cnt))) {
		(void) fprintf(stderr, "\nread error bno = %ld\n", bno);
		(void) fprintf(stderr, "count = %d; errno = %d\n", n, errno);
		(void) perror("bread");
		return -1;
	}
	return 0;
}
