#include <stdio.h>
#include <sys/param.h>
#include <sys/types.h>
#include "unrm.h"
#include "lists.h"
#include "init.h"

/*
 * ChangeDir - for interactive mode, the user can use the "cd" command
 * 	to switch the directory that files get unremoved to.  What we do
 * 	is, we switch the real and effective user-id's, call chdir, and
 * 	switch them back.
 */
void
ChangeDir(pchDir)
	char *pchDir;
{
	extern char *getwd();
	static char sb[MAXPATHLEN];

	if (-1 == setreuid(iTombUid, iUid)) {
		fprintf(stderr, "ChangeDir: can't change uid\n");
		perror("setreuid");
		exit(1);
	}
	if (-1 == setregid(iTombGid, iGid)) {
		fprintf(stderr, "ChangeDir: can't change gid\n");
		perror("setregid");
		exit(1);
	}
	if (-1 == chdir(pchDir)) {
		perror("chdir");
	}
	if (Verbose) {
		if (0 == getwd(sb)) {
			fprintf(stderr, "ChangeDir: getwd failed\n");
			exit(2);
		}
		printf("directory changed to %s\n", sb);
	}
	if (-1 == setreuid(iUid, iTombUid)) {
		fprintf(stderr, "ChangeDir: can't change uid back\n");
		perror("setreuid");
		exit(1);
	}
	if (-1 == setregid(iGid, iTombGid)) {
		fprintf(stderr, "ChangeDir: can't change gid back\n");
		perror("setregid");
		exit(1);
	}
}
