#include <sys/types.h>
#include "lists.h"

/*
 * Insert - insert the given element at the head of the given list.
 */
void
Insert(ppLElist, pLEelem)
	LE **ppLElist, *pLEelem;
{
	pLEelem -> next = *ppLElist;
	*ppLElist = pLEelem;
}

/*
 * SLInsert - insert the given element into the list at the point specified
 *	by the given function.
 */
void
SLInsert(ppLElist, pLEelem, func)
	LE **ppLElist, *pLEelem;
	int (* func)();
{
	int i;

	for (;;) {
		if (nilLE == *ppLElist) {
			*ppLElist = pLEelem;
			pLEelem -> next = nilLE;
			return;
		}
		i = (*func)(*ppLElist, pLEelem);
		if (i < 0) {
			/* advance */
			ppLElist = & (*ppLElist)->next;
			continue;
		}
		pLEelem->next = *ppLElist;
		*ppLElist = pLEelem;
		return;
	}
}

/*
 * Retrieve - return a pointer to the element indicated by cmpfunc, or
 *	nilLE if no such element can be found
 */
LE *
Retrieve(pLElist, cmpfunc)
	LE *pLElist;
	int (*cmpfunc)();
{
	while (nilLE != pLElist) {
		if (0 == (*cmpfunc)(pLElist))
			return pLElist;
		pLElist = pLElist -> next;
	}
	return nilLE;
}

/*
 * Delete - remove from the list the first element indicated by cmpfunc,
 *	and return a pointer to it.  If the element cannot be found, nilLE is
 * 	returned.
 */
LE *
Delete(ppLEList, cmpfunc)
	LE **ppLEList;
	int (*cmpfunc)();
{
	register int i;
	LE *pLE;

	for (;;) {
		if (nilLE == *ppLEList) {			/* empty */
			return nilLE;
		}
		i = cmpfunc(*ppLEList);
		if (0 == i) {					/* dinkme */
			pLE = *ppLEList;
			*ppLEList =  (*ppLEList)->next;
			return pLE;
		}
		ppLEList = & (*ppLEList)->next;
	}
}
