/*
 * we use this struct to build a linked list (sorted cronologically
 * by deletion time) of all the files entombed for this user on all
 * the filesystems on which we do entombing.
 */
typedef struct _le {
	struct _le *next;	/* next in the list			*/
	char *name;		/* name of this file			*/
	long size;		/* filesize in bytes			*/
	time_t date;		/* time entombed			*/
	int fs;			/* index into array of filesystem names	*/
} LE;

#define newLE()	((LE *)malloc(sizeof(LE)))
#define nilLE	((LE *)0)

extern void Insert();
extern void SLInsert();
extern LE *Retrieve();
extern LE *Delete();
