/*
 * Ls -- list the current working directory
 *	the arguments to this function is the command-line arguments
 *	to give to ls.
 */
#include <sys/wait.h>
#include <sys/types.h>
#include "lists.h"
#include "init.h"

void
Ls(pch)
	char *pch;
{
	switch (fork()) {
	case -1:
		perror("fork");
		exit(1);
		break;
	case 0:
		/* the child */
		break;
	default:
		/* the parent */
		(void) wait((union wait *)0);
		return;
	}
	if (-1 == setuid(iUid)) {
		perror("setuid");
		exit(1);
	}
	if (-1 == setgid(iGid)) {
		perror("getgid");
		exit(1);
	}
	(void) system(pch);
	_exit(0);
}
