#include <stdio.h>
#include <strings.h>
#include <sys/param.h>
#include <sys/dir.h>
#include <sys/wait.h>
#include <cmd.h>
#include "lists.h"
#include "init.h"
#include "fslist.h"
#include "show.h"

#define DEFPAGER "/usr/ucb/more"

/*
 * Show - invoke the user's pager with it's standard input set to the given
 *	file.
 */
void
Show(pchCmd)
	char *pchCmd;
{
	extern char *getenv();

	char *pchPager, *pch, *pchArgs, *pchFile, *pchRealFile;

	if (NULL == (pchPager = getenv("PAGER")))
		pchPager = DEFPAGER;

	/*
	 * the Plan here is to allow user to say "show -f foo" at the unrm
	 * prompt, where "-f" is some flag to his editor.  We grab a pointer
	 * to the arguments now, and we set the first space to NUL.  Then we
	 * take the last thing on the line to be the file name.  If the two
	 * pointers are the same, we know there were no arguments to the pager.
	 */

	pchArgs = pchFile = pch = pchCmd;
	if ('\000' == *pchArgs) {
		/* then there was just "show"	*/
		printf("usage: show <flags> <file>\n");
		return;
	}
	while (0 != strcmp("", pch = cmddlm(pchFile)))
		pchFile = pch;
	if (pchFile == pchArgs) {
		/* then there was just "show foo"	*/
		pchArgs = "";
	}
	pchFile[-1] = '\000';

	if (NULL == (pchRealFile = real_name(pchFile))) {
		printf("%s: no such file\n", pchFile);
		return;
	}

	switch (fork()) {
	case -1:
		perror("fork");
		exit(1);
		break;
	case 0:
		/* the child */
		break;
	default:
		/* the parent */
		(void) wait((union wait *)0);
		return;
	}
	if (NULL == freopen(pchRealFile, "r", stdin)) {
		perror(pchFile);
		exit(1);
	}
	if (-1 == setuid(iUid)) {
		perror("setuid");
		exit(1);
	}
	if (-1 == setgid(iGid)) {
		perror("getgid");
		exit(1);
	}
	if (0 != strcmp("", pchArgs))
		(void) execlp(pchPager, pchPager, pchArgs, (char *)0);
	else
		(void) execlp(pchPager, pchPager, (char *)0);
		
	perror("execlp");
	_exit(1);
}

